( 3iRadio.fs -- AE -- 2020-10-24---Sat---12:38 )

( Test setup:
    RF Nano TX on COM1 with 3iRadio_TX.avr -- GForth 1 open-com
    RF Nano RX on COM2 with 3iRadio_RX.avr -- RealTerm port 2
    
    test-radio [in GForth] produces four 9's  in RealTerm
)

$2A constant CALL_RFSTORE     
$2B constant CALL_RFCALL

\ Design: PC says 2 rfhi which sends 1 rfstore 2 rfstore 

: rfstore ( a     -- tx: --  rx: a  )     CMD_XSTORE swap 2 nstore  CALL_RFSTORE xcall ; 
: rfcall  ( instr -- remote: xcall  a )   rfstore CMD_XCALL xstore  CALL_RFCALL xcall ; 

: rfhi  ( pin -- ) 1 rfstore rfstore 1 rfcall ;
: rflo  ( pin -- ) 0 rfstore rfstore 1 rfcall ;


: test-radio 9 tx1 9 tx1 9 tx1 9 tx1 ;


: rfdelay 10 ms ;
\ : rftx1 rfdelay tx1 rfdelay ;

: test-rf 16 5 do i tx1 loop ;

: x_s  ( -- ) CMD_X_S tx1  CMD_XDROP tx1 ; \ redefining x_s to use xdrop not xfetch

: test-rf-led ( 1/0 -- )
    xstore  \ high
    13 xstore  \ pin4
    1 xstore  \ pinwrite instr
    4 xcall  ;    \ xcall 

\ : test-lights 6 2 do i high loop 20 ms 6 2 do i low loop ;  \ 20 ms works ( 10 ms fails ), on low power, 40cm away
\ : spin 50 0 do test-lights loop ;



: help-radio 
   cr
   cr ." HELP-RADIO"
   cr ." ----------"
   cr
   cr ."    9 tx1"
   cr ."    test-rf"
   cr ."    1 4 rfpinwrite"
   cr 
   cr ." Base instructions:  rfs  rfstore rfdrop rfcall"
   cr
;

\ ============================
help-radio


\ References
\ Understand the RF24 module
\   [0] RF24 Arduino library header file code:  
\       c:\totalprogs\arduino\libraries\RF24_Wireless_RF-Nano\RF24.h 
\
\ 	[1] Mechatronics quickstart howto: 
\ 		https://howtomechatronics.com/tutorials/arduino/arduino-wireless-communication-nrf24l01-tutorial/
\ 		Code example by: Dejan Nedelkovski, www.HowToMechatronics.com
\ 	
\ 	[2] Theory explained in depth: 
\ 		https://lastminuteengineers.com/nrf24l01-arduino-wireless-communication/
\ 
\     [3] Interrupts:
\ 		https://myplayground123.wordpress.com/2017/05/19/nrf24l01-with-interrupt-on-receiver/


\  2021-10-24---Sun---11:40 refactored Radio wireless for better foundation for building on top of